#ifndef __BADFILENAMEEXCEPTION_H__
#define __BADFILENAMEEXCEPTION_H__

#include <exception>
#include <string.h>

/**@file badfilename.h defines badfilename exception class
 */

/** exception thrown when file does not contain the right information or does not exist
 */
class badfilename{

  std::string message;
 public:
  
  badfilename()
    {
    }
  ~badfilename()
    {
    }
  
  /**Constructor
   *@param f filename
   *@param e explanation of what has gone wrong
   */
  badfilename(char* f, char* e){
    message = "IO error with file ";
    message = message + f + ": " + e; 
  }

  badfilename(std::string f, std::string e){
    message = "Error reading file ";
    message = message + f + ": " + e;
  }

  /**what() method
   *@return "Error read file <filename>: <explanation>"
   */
  std::string what() const {
    return message;
  }
};
#endif
