#ifndef CARDIN_MCV_H
#define CARDIN_MCV_H
//Memory leak detection:
//#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
//#include <crtdbg.h>
#include "haplotype.h"
//#include "Niall_Utils.h"
#include "Imp_Sampler.h"
#include "LookD_Copy.h"
#include "control.h"




using namespace std;

class CC_and_McV : public CLookD_Copy
{
public:
	CC_and_McV(const Con& input_con, const double& input_rho, const double& input_rho_per_site, 
		const int& input_smpl_size, const int& input_all_sites, const int& input_no_segsts, const int& input_rec_sites, 
		double& input_DEBUG, const bool& input_SMC, const bool& input_cheap_coal_upwt, const bool& input_using_rec_map,
		const bool& input_importance_sample, const bool& input_know_derived, const vector<bool>& input_still_segregating, 
		vector<haplotype>& input_hap_list, const vector<double>& input_rec_map, Random* Inst_of_random, 
		const vector<double>& input_site_posns, const vector<int>& input_index_live, const bool& input_coal_fast, const bool& input_greedy_mle): 
	
	CLookD_Copy(input_con, input_rho, input_rho_per_site, 
		input_smpl_size, input_all_sites, input_no_segsts, input_rec_sites, 
		input_DEBUG, input_SMC, input_cheap_coal_upwt, input_using_rec_map, 
		input_importance_sample, input_know_derived, input_site_posns, input_still_segregating, 
		input_hap_list, input_rec_map, Inst_of_random, input_index_live, input_coal_fast, input_greedy_mle)
	{
		CandMcV2_DEBUG  = 0;
		using_ms_theta  = 1; // As opposed to some kind of Watterson estimate
		watterson		= -1;
	}	
	~CC_and_McV() {}

	// Dynamic Porgramming Functions:
	void Look_Down_and_Copy(const haplotype& alpha, const bool& reverse, vector<double>& lProb_up_to, double& loutput_likelihood);

protected:
	bool CandMcV2_DEBUG;
	bool time_correction;
	bool using_ms_theta;
	double watterson;

	vector<vector<int> >	random_ordering;	
	bool Condition(int j, bool reverse);

	void Quadrature(int quad_points);
	vector<long double> weights;
	vector<long double> abscissae;

	vector<double>  CandMcV2_Mutation_Cost(int quad_points);
	vector<double>  CandMcV2_Recombination_Cost(int current_site, int quad_points, int increment);
	long double		R_bar(vector<double> R, int quad_points);			
};


#endif
