#ifndef LI_AND_STEPHENS_H
#define LI_AND_STEPHENS_H
//Memory leak detection:
//#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
//#include <crtdbg.h>

#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <limits>		// Debugging Code

#include "haplotype.h"
//#include "Niall_Utils.h"
#include "Imp_Sampler.h"
#include "LookD_Copy.h"
#include "control.h"


#define m_min(a,b) ((a) <= (b) ? (a) : (b))
#define m_max(a,b) ((a) >= (b) ? (a) : (b)) 

using namespace std;

class CL_and_S : public CLookD_Copy
{
public:
	CL_and_S(const Con& input_con, const double& input_rho, const double& input_rho_per_site, const int& input_smpl_size, const int& input_all_sites, 
		const int& input_no_segsts, const int& input_rec_sites, double& input_DEBUG, const bool& input_SMC, const bool& input_cheap_coal_upwt,
		const bool& input_using_rec_map, const bool& input_importance_sample, const bool& input_know_derived, const vector<bool>& input_still_segregating, 
		vector<haplotype>& input_hap_list, const vector<double>& input_rec_map, 
		Random* Inst_of_random, const vector<double>& input_site_posns, const vector<int>& input_index_live, const bool& input_coal_fast, const bool& input_greedy_mle): 
	
	CLookD_Copy(input_con, input_rho, input_rho_per_site, input_smpl_size, input_all_sites, input_no_segsts, input_rec_sites, 
		input_DEBUG, input_SMC, input_cheap_coal_upwt, input_using_rec_map, input_importance_sample, input_know_derived, 
		input_site_posns, input_still_segregating, input_hap_list, input_rec_map, Inst_of_random, input_index_live, 
		input_coal_fast, input_greedy_mle)
	{
		LandS_DEBUG = false;
	}	
	~CL_and_S() {}

	// Dynamic Porgramming Functions:
	double LandS_Prob_Mutation();
	vector<double> LandS_Recombination_Cost(int current_site, int increment);
	void       Look_Down_and_Copy(const haplotype& alpha, const bool& reverse, vector<double>& lProb_up_to, double& loutput_likelihood);
	void Look_Down_and_Copy_nolog(const haplotype& alpha, const bool& reverse, vector<double>& lProb_up_to, double& loutput_likelihood);

protected:
	bool LandS_DEBUG;
	bool time_correction;

	//vector<double>	lProb_up_to; 
	//double			loutput_likelihood;

	//Temporary measure to make it compile.
	vector<vector<int> >	random_ordering;
	//For the jth site on the ith lineage use: hap_list.at(index_live.at(i)).alleles.at(j)

	bool Condition(int j, bool reverse);
};

#endif

