#ifndef LOOKD_COPY_H
#define LOOKD_COPY_H
//Memory leak detection:
//#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
//#include <crtdbg.h>

#include <stdio.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <limits>		// Debugging Code

#include "haplotype.h"
#include "Imp_Sampler.h"
#include "control.h"



using namespace std;

class CLookD_Copy : public Imp_Sampler
{
public:
	CLookD_Copy(const Con& input_con, const double& input_rho, const double& input_rho_per_site, const int& input_smpl_size, const int& input_all_sites, const int& input_no_segsts, const int& input_rec_sites, double& input_DEBUG, const bool& input_SMC, const bool& input_cheap_coal_upwt, const bool& input_using_rec_map, const bool& input_importance_sample, const bool& input_know_derived, const vector<double>& input_site_posns, const vector<bool>& input_still_segregating, vector<haplotype>& input_hap_list, const vector<double>& input_rec_map, Random* Inst_of_random, const vector<int>& input_index_live, const bool& input_coal_fast, const bool& input_greedy_mle):
	Imp_Sampler(input_con, input_rho, input_rho_per_site, input_smpl_size, input_all_sites, input_no_segsts, input_rec_sites, input_DEBUG, input_SMC, input_cheap_coal_upwt, input_using_rec_map, input_importance_sample, input_coal_fast, input_greedy_mle, input_know_derived, input_site_posns, input_still_segregating, input_hap_list, input_rec_map, Inst_of_random)
	{
		LookD_Copy_Debug = 0;
	}	
	virtual ~CLookD_Copy() 
	{
		//cout << "Inside the Look_down_and_Copy destructor\n";
	}; //destructor.

	//General Importance Sampling functions:	
	int  Choose_Event(int& daughter1, int& daughter2, int& rec_lineage, int& rec_site, int& mut_lineage, int& mut_site, int& new_type, double& event_weight, const double& rec_rate, const double& coal_rate, const double& mut_rate, const double& evnt_rate, const double& threshold);
		void Back_track(const int& unindexed_alpha, const int& unindexed_daught2, const double& lineage_rate, double& lsymmetric_likelihood, const int& passed_daught2);
	int  Choose_from_all_events(int& daughter1, int& daughter2, int& rec_lineage, int& rec_site, int& mut_lineage, int& mut_site, int& new_type, double& event_weight);
	void calc_upweightings(int& daughter1, int& daughter2, int& rec_lineage, int& rec_site, int& mut_lineage, int& mut_site, int& new_type);
	void Choose_Pair(int& daughter1, int& daughter2);
	void Choose_rec_details(int& lineage, int& rec_from, int& rec_to);
	void Coal_Create_aUb(const haplotype& alpha, const haplotype& beta, haplotype& aUb); 
	void Coal_Create_aTTb(const haplotype& alpha, const haplotype& beta, haplotype& aTTb);
	
	// Dynamic Porgramming Functions:
	virtual void       Look_Down_and_Copy(const haplotype& alpha, const bool& reverse, vector<double>& lProb_up_to, double& loutput_likelilood);
	virtual void Look_Down_and_Copy_nolog(const haplotype& alpha, const bool& reverse, vector<double>& lProb_up_to, double& loutput_likelilood);
	

protected:
	bool LookD_Copy_Debug;
	bool time_correction;
	bool quick_Li_and_Stephens;
	vector<bool> can_nonrec;

	//inline int Live_Site(int allele);	

	vector<double>	lProb_up_to; 
	double			loutput_likelihood;
	void Display_Weights(const vector<double>& lcoal_weights, const vector<double>& lmut_weights, const vector<double>& lrec_weights);
	void Display_Complex_Weights(const int& unindexed_alpha, const vector<vector<double> >& matrix_lcoal_weights, const vector<vector<double> >& matrix_lmut_weights, const vector<vector<double> >& matrix_lrec_weights);
	void Remove_alpha_index(const int& index_alpha);
	void Restore_alpha_index(const int& index_alpha);

};

#endif
