#include "Simple_IS.h"
#include "Imp_Sampler.h"

/*For possible problems with this method see end*/
void CSimple_IS::calc_upweightings(int& daughter1, int& daughter2, int& rec_lineage, int& rec_site, int& mut_lineage, int& mut_site, int& new_type)
{
	int rec_to; //probably redundant
	int no_singletons;
	//Coal upweighting:
	
	CEvent non_event;
	int coal_possible = count_coal_pairs(non_event); // This function calculatees ALL pairs of sequences that can coalesce.
	if (coal_possible)
		//coal_upweight = (double)smpl_size/((double)pr_coal_rate*2.0);
		coal_upweight = 100;
	else
		coal_upweight = 0;
	if(DEBUG>1)
		cout << "The number of pairs that can coalesce is: " << coal_possible << endl;	
	
	//Mutation upweighting
	no_singletons = count_singletons(non_event);
	if (no_singletons)
	{
		//cout << "Found a singleton mutation! Might try to remove it now.\n";
		mut_upweight = (double)smpl_size/((double)pr_mut_rate*2.0);
		Choose_Mutation(mut_lineage, mut_site, new_type, no_singletons);
	}
	else 
		mut_upweight = 0;
	
	//Recombination - Difficult! May try various forms of this.
	Display_Haplotypes();
	Choose_rec_details(rec_lineage, rec_site, rec_to);
	rec_upweight  = 1;	
}







// This function chooses where to recombine. It might cal a number of functions to help it decide.
void CSimple_IS::Choose_rec_details(int& lineage, int& rec_from, int& rec_to)
{
	// This function doesn't work yet!
	//calc_longest_idy(lineage, rec_from, rec_to);

	//Gil thinks that this is a better idea.
//	calc_sums_of_idy(lineage, rec_from, rec_to);


}

// Need to know what KIND of identity is good enough, what's the identity between: 00110110 and 00010010 ?? (Currently it's 2)
// Hopefully knowledge of the longest stretch of identity will help decide WHERE to recombine and on WHICH sequence.
// Can either SUM identity over all other sequences, for each sequence. Or can simply calculate MAX and then choose with P(1/2)
// This function calculates the 'longest' stretch of identity between pairs of sequences
int CSimple_IS::calc_longest_idy(int& lineage, int& rec_from, int& rec_to)
{
	int i,j,k;
	int overall_max =0;
	
	int best_length;
	int temp_length;
  int start_id;
	int max_i         = -999999999; //std::numeric_limits<int>::quiet_NaN();
	int max_j         = -999999999; //std::numeric_limits<int>::quiet_NaN();
	int temp_start_id = -999999999; //std::numeric_limits<int>::quiet_NaN();
	int end_id        = -999999999; //std::numeric_limits<int>::quiet_NaN();
	
	// All of these things should be updated after events, not constructed from scratch like this
	
	//where_max[start/end][lineage]
	where_max.clear();		where_max.resize(2);where_max.at(0).resize(actv_lngs,-1); where_max.at(1).resize(actv_lngs,-1);
	sum_identity.clear();	sum_identity.resize(actv_lngs,0);
	max_identity.clear();	max_identity.resize(actv_lngs,0);
	max_with_who.clear();	max_with_who.resize(actv_lngs,-1);

	for(i=1; i<actv_lngs; i++)
	{
		if(hap_list.at(index_live.at(i)).rec_dist > 0)
		{
			for(j=0; j<i; j++)
			{
				if(hap_list.at(index_live.at(j)).rec_dist > 0)
				{
					temp_length = 0; best_length = 0; start_id = -1;
					// Go through every site, adding up sites where : *They are both ancestral and both agree*
					for(k=0; k<no_segsts; k++)
					{
						if(hap_list.at(index_live.at(i)).alleles.at(k) && hap_list.at(index_live.at(j)).alleles.at(k))
						{
							if(hap_list.at(index_live.at(i)).alleles.at(k) == hap_list.at(index_live.at(j)).alleles.at(k))
							{
								if(start_id == -1) temp_start_id = k;
								sum_identity.at(i)++;	
								sum_identity.at(j)++;	
								temp_length ++;
							}
							// When they disagree have to start again. First store how much identity had been found at this point.
							else 
							{
								if(temp_length > 0 &&temp_length >= best_length) //This is the longest stretch of identity found between these to lineages so far.
								{
									if(temp_length == best_length) 
									{
										//Make some kind of stochastic decision?
									}
									max_i		= temp_length;
									max_j		= temp_length;						
									start_id	= temp_start_id;
									end_id		= k-1;						
									best_length = temp_length;
								}
								temp_start_id	= -1; 						
								temp_length		= 0;						
							}
						}
						//Here at least one the sequences is NOT ANCESTRAL at this site.
						else
						{
							// If we're currently in a region of identity, then:
							if (start_id)
							{
								// These have been commented out to avoid inconcistency. (Reading Left to Right vs. Right to Left)
								//sum_identity.at(i)++;	
								//sum_identity.at(j)++;	
								//temp_max_i ++;
								//temp_max_j ++;
							}
						}
					//	if(max_i < temp_length) max_i = temp_length;
					//if(max_j < temp_length) max_j = temp_length;					
					}
					if(start_id != -1) // If we're in a region of identity when we reach the end of the sequence:
					{
						if(temp_length > 0 &&temp_length >= best_length) //This is the longest stretch of identity found between these to lineages so far.
						{
							if(temp_length == best_length) 
							{
								//Make some kind of stochastic decision?
							}
							max_i		= temp_length;
							max_j		= temp_length;						
							start_id	= temp_start_id;
							end_id		= no_segsts-1;						
							best_length = temp_length;
						}
						temp_start_id	= -1; 						
						temp_length		= 0;
					}
					if(max_i >= max_identity.at(i))
					{
						if(max_i != 0 && max_i == max_identity.at(i))
						{
							// Choose stochstically between these two for which should be 'current max(identity)_with_whom ';
						}
						else
						{
							max_with_who.at(i) = j;
							max_identity.at(i) = max_i;
						}
					}
					if(max_j != 0 && max_j >= max_identity.at(j))
					{
						if(max_j == max_identity.at(j))
						{
							// Choose stochstically between these two for which should be 'current max(identity)_with_whom ';
						}
						else
						{
							max_with_who.at(j)		= i;
							max_identity.at(j)		= max_j;
							//where_max[start/end][lineage]
							where_max.at(0).at(j)	= start_id;
						}
					}			
					// Need then to choose stochastically between these two equivalent lineages.
					if(overall_max <= max_j)
					{
						if (overall_max == max_j)
						{
							//Have to do something stochastic here.
						}
						overall_max = max_j;
						best_a = i;
						best_b = j;
					}
					if(max_i >= max_identity.at(i))
					{
						// Note the order of indices! This way around to save on resizing time.
						// where_max[start/end][lineage]
						where_max.at(0).at(i) = start_id;
						where_max.at(1).at(i) = end_id;
					}
					if (max_j >= max_identity.at(j))
					{
						where_max.at(0).at(j) = start_id;
						where_max.at(1).at(j) = end_id;
					}
				// End of 'j' (second lineage) loop.
				}
			}
		}
	}
	if(max_or_sum) // 0 = Max and 1 = Sum
	{
		lineage	 = index_live.at(best_a); //Should choose this stochastically.
		rec_from = where_max.at(0).at(best_a);
		rec_to   = where_max.at(1).at(best_a);
	}
	else
	{

	}
	return overall_max;
}














/*****
A potential problem with the simple minded importance sampler is it's inability to consider the:

SAMPLE CONFIGURATION OF THE DATA AFTER an event.

While this may not be important after a mutation or recombination event it may WELL be important after a coalescence event.
There is no problem when all of the sequences are FULLY ANCESTRAL but when the sequences are highly NON-ANCESTRAL
many coalescence events will result in sequences that require FURTHER RECOMBINATION.

However, it's not so easy to come up with an example where there's an obvious problem:

001
001
011

could become:

0--
-01
001
011

None of the coalescence events here seem to harm the rate at which we reach the MRCA.
In any case, this question of resulting sample configurations requires some serious thought and identifying those events where
it is important and cases where it might be could really help the sampler. 

Does TRAPPED non-ancestral material come into this?
Does the SMC help with the places where this might be a problem?

Matthew Stephens: The point is that when rho is, say 20, the histories will be extremely complex and varied so it feels like 
there's no hope of any kind of reasonable sampling over such a space.
Matthew Stephens: We need to ask the question of whether this approach of maximum parsimony is really aiming to achieve the 
right thing, so we WANT to ignore as many recombination events as we can get away with?
******/


