#ifndef SIMPLE_IS_H
#define SIMPLE_IS_H

//Memory leak detection:
//#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
//#include <crtdbg.h>

#include "Imp_Sampler.h"
#include <stdio.h>
#include <iostream>
#include <vector>

#include "haplotype.h"
#include "recomb_event.h"
//#include "node.h"



using namespace std;

class CSimple_IS : public Imp_Sampler
{
public:
//CSimple_IS(){cout << "Error,  default constructor for Simple_IS should not be called." << endl; getchar();}; //I thought that this should never be called.

	CSimple_IS(const Con& input_con, const double& input_rho, const double& input_rho_per_site,
	    const int& input_smpl_size, const int& input_all_sites, const int& input_no_segsts, const int& input_rec_sites,
	    double& input_DEBUG, const bool& input_SMC, const bool& input_cheap_coal_upwt, const bool& input_using_rec_map, const bool& input_importance_sample, const bool& input_know_derived, const vector<double>& input_site_posns, const vector<bool>& input_still_segregating, vector<haplotype>& input_hap_list, const vector<double>& input_rec_map, Random* Inst_of_random, const bool& input_coal_fast, const bool& input_greedy_mle):
	Imp_Sampler(input_con, input_rho, input_rho_per_site, input_smpl_size, input_all_sites, input_no_segsts, input_rec_sites, input_DEBUG, input_SMC, input_cheap_coal_upwt, input_using_rec_map, input_importance_sample, input_coal_fast, input_greedy_mle, input_know_derived, input_site_posns, input_still_segregating, input_hap_list, input_rec_map, Inst_of_random)
	{};
	~CSimple_IS(){
		//cout << "Called CSimple_IS destructor" << endl;
	};

	void calc_upweightings(int& daughter1, int& daughter2, int& rec_lineage, int& rec_site, int& mut_lineage, int& mut_site, int& new_type);
		//int  count_singletons();
	void Choose_rec_details(int& lineage, int& rec_from, int& rec_to);
		int calc_longest_idy(int& lineage, int& rec_from, int& rec_to);
protected:
	int no_singletons;
	int no_identical;
	int greatest_identity;

	// This variable is to help choose which aspect of maximum identity we wish to use to choose recombination events.
	bool max_or_sum; // 0 = Max and 1 = Sum

private:
	// Longest identity variables:
	vector<int> sum_identity;			// This vector gives the total amount of ANCESTRAL identity between this sequence and ALL of the others
	vector<int> max_identity;			// This vector says what the amount of identity a given sequence has with it's 'most similar' sequence
	vector<int> max_with_who;			// This identifies who is the most similar sequence to this sequence
	vector< vector<int> > where_max;	// This vector identifies the start and end of the regions of maximum identity.
	int best_a;
	int best_b;

	
};

#endif
