/*
 * argumentsOfProgram.cpp
 *
 *  Created on: Jun 16, 2010
 *      Author: Niall Cardin
 */
#include "argumentsOfProgram.h"


//argumentsOfProgram::argumentsOfProgram(int argc, char *argv[])
//argumentsOfProgram::argumentsOfProgram(Random* Inst_of_random)
argumentsOfProgram::argumentsOfProgram()
{
  // int DEBUG_LEVEL = 2;
  // set_ran(Inst_of_random); // Need to look at how this line works.

  theta             = 1e-9 ;  // sets default - mutation rate
  rho               = 1e-9 ;  // sets default - recombination rate
  SMC               = true ;  // sets default - should the program use the SMC model (if not, then the full coalescent)
  importance_sample = true ;  // sets default - should the program perform importance sampling? Set to 1 even for intelligent tree simulation.
  sim_data          = false;  // sets default - should the program simulate data (probably not implemented yet)?
  using_rec_map     = false;  // sets default - should the program use an explicit rec_map? Set to FALSE as this is done a different way
  all_nodes         = true ;  // sets default - should the program output the leaf nodes in the genealogies (redundant info, but maybe convenient)
  DEBUG             = 0    ;  // sets default - affects behaviour for minor exceptions and control level of output to the console
  verbose           = 1    ;  // sets default - new barely implemented variable: controls level of console output
  sampler           = 2    ;  // sets default - what approximation to P(H1 | H2, ..., Hn) be used. 2 is Li & Stephens. Only 4 is also implemented. (set it to 1)
  no_runs           = 1;      // sets default - how many genealogies to simulate per location?
  change_rho        = 0;      // sets default - Simulate genealogies for multiple value of rho (useful for likelihood calculations) - if >0 then value is the number of different values tried
  bridge_resolution = 110;    // sets default - used in likelihood calculation. Sets density of bridge sampling based likelihood values (just: how many do you want?)
  change_theta      = 0;      // sets default - Simulate genealogies for multiple value of theta (useful for likelihood calculations) - if >0 then value is the number of diifferent values tried
  greedy_mle        = true ;  // sets default - This tries to find a single 'best' ARG. When true program is NOT stochastic, should only have use run.
  choose_hap_first  = true ;  // sets default - Chooses a faster method of generating genealogies - next even hap chosen from prior rates. See FearnHead & Donnelly (2000) or the thesis of cardin (2006)
  coal_fast         = true ;  // sets default - A 'fast' method of generating genealogies, not great for likelihood calculation
  threshold         = 0.2  ;  // sets default - (0 < Threshold < 1, sets how approximate the genealogies are with coal fast)
  choose_nonrec     = true ;  // sets default - Supposed to be a very fast method of generating genealogies - but makes little difference)
  first_nonrec      = false;  // sets default - A very fast method of generating genealogies)
  use_logs          = true ;  // sets default - Should calculations within the Li&Stephens function use logs (faster if they don't, but underflow problems)?
  cheap_coal_upwt   = false;  // sets default - always set to false
  display_events    = false;  // sets default - This displays every event in each genealogy when No Runs is small.
  display_haps      = false;  // sets default - This displays the haplotypes in each epoch
  display_weights   = false;  // sets default - This displays the weights for each event in each epoch
  set_seed          = 1    ;  // sets default - Put in a positive integer, n, here and the seed will be set to -n (else uses system clock to set seed)
  using_wattersons  = true ;  // sets default - Should the Watterson estimate of 'theta' be used? If not then theta defined above is used
  write_likelihoods = false;  // sets default - should the average likelihoods should be written to file
  write_trees       = true ;  // sets default - should the trees should be written to file
  write_full_data   = false;  // sets default - should every likelihood should be written to file
  writeType         = "oldStyle"; //  default - What type of tree format to use at the end (if writing trees)
  outputDir         = "./test_output/";  // sets default - By default output files will be placed in the directory run from.
  output_MLE        = false;  // sets default - Must remain at false - not fully implemented yet.
  collect_times     = true ;  // sets default - should certain patterns of tMRCA across sequences should be stored
  record_every_time = true ;  // sets default - should tMRCA at every site should be recorded on every iteration
  collect_densities = false;  // sets default - This indicates whether to report the density of each ARG.
  file_tag          = "test"; //d - a string to be appended to output files. Can (and proably should) be set at the command line for multiple runs of the program
  tree_file_prefix  = "use_default"; // deflt - prefix to put on the front of treeOutput files
  dataFormat        = "hapmap"     ; // deflt - names of the data input format to be used - use 'hapmap' unless you know whhat you're doing.
  useHapmap = dataFormat=="hapmap" ; // deflt - somewhat redundant boolean to record whether hapmaap input data being used.

  hapmapParams.legend_file       = "testFiles/testLegend1.txt";       //default filename
  hapmapParams.haps_file.fName   = "testFiles/testHaps1.txt"  ;       //default filename
  hapmapParams.map_file          = "testFiles/testMap1.txt"   ;       //default filename
  hapmapParams.upper             = -1;                                //default upper bound for region to analyse
  hapmapParams.lower             = -1;                                //default lower bound for region to analyse
  hapmapParams.buffer            = -1;                                //default region around results region to avoiid edge effects
  hapmapParams.display_width     = 10;                                //default display setting, unimportant
  hapmapParams.Ne                = 1e4;                               //default effective population size
  hapmapParams.strand_file.fName = "strand file not implemented yet";
  hapmapParams.sample_file.fName = "sample file not implemented yet";
  hapmapParams.rhoScale          = "cMperMb"; //alt="coalescentScale" // default scale on which to measure recombination rate

  debugMaxNumHaps   = -1        ; // deflt - Just for debugging, can be used to reduce the number of haplotypes

  data_Fname        = "obsolete"; // deflt - probably obsolete. filename for make-sample style data
  which_set         = 1         ; // deflt - probably obsolete. which data set to be used with make-sample style data with multiple data sets in one file...
  snp_names_file    = "no_file" ; // deflt - probably obsolete. filename the specifies a file which gives SNP names - with make-sample style data
};
