#ifndef CONTROL_H
#define CONTROL_H

//#include "haplotype.h"
//#include "recomb_event.h"
//#include "node.h"
//#include "Imp_Sampler.h"
//#include "Simple_IS.h"
//#include "Li_and_Stephens.h"
//#include "LookD_Copy.h"
//#include "Cardin_McV.h"
//#include "event.h"
#include "argumentsOfProgram.h"

using namespace std;

class Con : public argumentsOfProgram
{
public:

  Con(const argumentsOfProgram& arguments)  :
    argumentsOfProgram(arguments),
    smpl_size(-1)  , no_segsts(-1)  ,
    rec_sites(-1)  , rec_rate(-1.0) ,
    coal_rate(-1.0), mut_rate(-1.0) ,
    evnt_rate(-1.0)
  {
  }
  ;
  Con()
  {
    cout << "  Warning! Inside the default constructor of Con, should not be called.\n";
    cout << "  Press any key to continue:";
    getchar();
    cout << "\n";
  };
  ~Con() {
    //cout << "Called Control Structure, Con's, Destructor" << endl;
  };

  //variables create within the program:
  // usually these record (highly) dynamic states
  int smpl_size;
  int node_MRCA;
  int all_sites;
  int no_segsts;
  int rec_sites;
  int actv_lngs;
  int dead_lngs;
  int MRCA_lngs;
  double crnt_height;
  double rec_rate;
  double coal_rate;
  double mut_rate;
  double evnt_rate;
  int evnt_nmbr;
  //int debugMaxNumHaps;

  //options that are not currently set at command line
  bool print_data;
  bool display_tree;
  bool know_derived;
};

#endif

