/*
 * ChapmapParams.h
 *
 *  Created on: Jun 16, 2010
 *      Author: niall
 */

#ifndef ChapmapParams_H_
#define ChapmapParams_H_

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <limits>
#include <string>
#include <vector>
#include <set>

/*class myFile {
  string string(string filename) {
    return filename;
  }
};*/

using namespace std;

struct myFile{
  string fName;
};

class ChapmapParams {
  public:

  ChapmapParams(  // See end of file for a better way to write these two constructors:
      const string& input_haps_file,
      const string& input_legend_file,
      const string& input_map_file,
      const int& input_upper ,
      const int& input_lower ,
      const int& input_buffer,
      const string& input_rhoScale
      )
  {
    //dataRoot          = "/home/niall/Documents/programming/eclipse/testFiles/";
    //fNameConstruct    << "";
    //haps_file.fName   = fNameConstruct.str()  ;
    gens_file.fName    = "no genotypes file used in this program";
    strand_file.fName  = "no strand    file used in this program";
    sample_file.fName  = "no sample    file used in this program";
    haps_file.fName = input_haps_file  ;
    legend_file     = input_legend_file;
    map_file        = input_map_file   ;
    upper    = input_upper ;
    lower    = input_lower ;
    buffer   = input_buffer;
    rhoScale = input_rhoScale;
  };

  ChapmapParams(): upper(10.5*1e6), lower(10.0*1e6), buffer(5), display_width(10), Ne(1e4)
  {
//    haps_file.fName   = "/home/niall/Documents/programming/eclipse/testFiles/testHaps1.txt.gz"  ;
//    legend_file       = "/home/niall/Documents/programming/eclipse/testFiles/testLegend1.txt.gz";
    //dataRoot          = "/home/niall/Documents/programming/eclipse/testFiles/";
    //fNameConstruct    << dataRoot << "testHaps1.txt";
    haps_file.fName   = "/home/niall/Documents/programming/eclipse/testFiles/testHaps1.txt"  ;
    legend_file       = "/home/niall/Documents/programming/eclipse/testFiles/testLegend1.txt";
    map_file          = "/home/niall/Documents/programming/eclipse/testFiles/testMap1.txt"   ;
    //haps_file.fName   = "/Users/Shared/work/treesim/testFiles/testHaps1.txt";
    //legend_file       = "/Users/Shared/work/treesim/testFiles/testLegend1.txt";
    //map_file          = "/Users/Shared/work/treesim/testFiles/testMap1.txt"   ;
    gens_file.fName   = "no genotypes file used in this program";
    strand_file.fName = "no strand    file used in this program";
    sample_file.fName = "no sample    file used in this program";

//    upper  = 10   * 1e6; //SNPs for main results start 10kb into the chromosome
//    lower  = 10.5 * 1e6; //SNPs for main results end   20kb into the chromosome
//    buffer = 5         ; //Read in 5kb of worth of SNPs either side to improve results at wanted SNPs.

    //cout << "Called ChapmapParams Constructor" << endl;
  };
  ~ChapmapParams()
  {
    //cout << "Called ChapmapParams Destructor" << endl;
  };

  //string dataRoot;
  myFile gens_file;
  myFile haps_file;
  string legend_file;
  string map_file;
  myFile sample_file;
  myFile strand_file; //surely this shoudn't be needed?

  int upper;
  int lower;
  int buffer;

  //double call_thresh; //Surely this shouldn't be needed?
  int display_width;

  int Ne;
  int nind;
  string rhoScale; //eg. "coalescentScale", "cMperMb"

  myFile exclude_samples;
private:
  //stringstream fNameConstruct;

};


#endif /* ChapmapParams_H_ */
