#include "main.h"

int main(int argc, char* argv[]) {
  /*int tmpDbgFlag;
   * Set the debug-heap flag to keep freed blocks in the
   * heap's linked list - This will allow us to catch any
   * inadvertent use of freed memory
   tmpDbgFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
   tmpDbgFlag |= _CRTDBG_DELAY_FREE_MEM_DF;
   tmpDbgFlag |= _CRTDBG_LEAK_CHECK_DF;
   _CrtSetDbgFlag(tmpDbgFlag);
   _CrtSetReportMode( _CRT_ERROR, _CRTDBG_MODE_DEBUG );*/

  try {
    // Initialisation of variables in main
    Random Inst_of_random; // Set up random number generator, do that here so as to ensure only one instance so all choices are unrelated.
    //Read in command line arguments, and set other parameters to defaults:
    parameters par(argc, argv);

    /*
    // par.read_parameters();
    // Set up main object of program given command line arguments and other settings:
    //cout << "par.hapmapParams.haps_file.fName = " << par.hapmapParams.haps_file.fName << "\n";
    //cout << "par.bridge_resolution            = " << par.bridge_resolution            << "\n";
    //cout << "par.display_haps                 = " << par.display_haps                 << "\n";*/
    Ancestry History(&Inst_of_random, par); // Create genealogy object

    // Some debugging output to check that data has been read in properly:
    //cout << "  History.getDataSize() = " << History.getDataSize()
    //    << " (in main) \n";
    if (History.getDataSize() == 0)
      cout
          << "  Warning! data is of size 0 (in main). Problem reading in data?\n";

    // Main routine of program - generate histories conditional on the data and output results to file
    History.Controller();
  } catch (const int& e) {
    cout << "An integer exception occurred. Exception Nr. " << e << endl;
  } catch (const string& s) {
    cout << "A default exception occurred:\n" << s << endl;
  } catch (const badfilename& bad) {
    cout << "A Bad Filename exception occurred" << endl;
    cout << bad.what() << "\n";
    //bad.badfilename(bad);
  }
  //  catch (...)
  //  {
  //    cout << "A default exception occurred" << endl;
  //  }


  /*
   //myFileName = "NickTest.txt";
   ifstream NickTestF;
   NickTestF.open("NickTest.txt");
   int NickInt = 0;
   //char NickChar[50];
   //NickTestF >> NickChar;
   NickTestF >> NickInt;
   //cout << "NickChar = " << NickChar << "\n";
   cout << "NickInt = " << NickInt << "\n";
   cout << "NickTestF.bad() = " << NickTestF.bad() << "\n"
   << "NickTestF.good() = " << NickTestF.good() << "\n"
   << "NickTestF.fail() = " << NickTestF.fail() << "\n"
   << "NickTestF.eof() = " << NickTestF.eof() << "\n";
   //cout << "(int)(NickChar[0]) = " << (int)(NickChar[0]) << "\n";

   int consoleInt;
   cout << "Please insert an integer and press enter: ";
   cin >> consoleInt;
   cout << "\nYou inserted: " << consoleInt << "\n";
   getchar();
   */
  return 0;
}

/*
 >Completing Functionality:
(!) Currently if the genetic map doesn't cover the SNPs there's warningless behaviour which essentially sets rho==0.
 Add in 'maximising identity' code for recombinations.


 >Proper Functionality:

 >Tweaking Functionality:

 Where I make arbitrary decisions (such as using > signs where >= would do) I need to make ir properly stochastic to avoid BIAS!!
 Is the above still an issue?

 >Speed:

 Updating: 
 index_live,
 can_coals (including SMC),
 can_muts
 max_identity
 sum_identity

 after each event probably quicker than doing from scratch
 HOW to update something when it gets SMALLER? is INDEX_LIVE the answer for ALL of them?
 
 When doing hap first check to see if a non-recombination event can occur, if it can upweight (by 1/rho?)
 
 *Don't delete any of the original functions though! They will all make up valuable CHECKING/DEBUGGING code.*****

 Making random choices in a form guarenteed to stop probably faster (ie, only choose between valid events, rather than choosing from all and then rejecting).
 */
