#ifndef NODE_H
#define NODE_H


//Memory leak detection:
#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
//#include <crtdbg.h>


class node
{
public: 
  // This line explicitly sets pointers n1,2 to 0 which has a special interpretation.
  // This allows if(n1) to return false when n1 hasn't been assigned to anything useful.
  node() : n1(0), n2(0) {  };
  ~node() {};

  // These pointers point to the daughter nodes in the genealogy.
  // Leaf nodes have no daughters (and remain at 0, as specified in the default constructor).
  node* n1;
	node* n2;

	node* getN1() const {
	  if(n1==NULL) {
      std::cout << "  Warning in class 'node'. Call to getN1 when thisNode.n1 is null.\n";
      std::cout << "  Perhaps this is a leaf node?\n";
	  }
	  return(n1);
	}
  node* getN2() const {
    if(n2==NULL) {
      std::cout << "  Warning in class 'node'. Call to getN2 when thisNode.n2 is null.\n";
      std::cout << "  Perhaps this is a leaf node?\n";
    }
    return(n2);
  }

	double c_time;
	double time_below;
	bool   active;
	int    index_site;
	int    index_epoch;
};

#endif
