/*
 * The following constructor for Ancestry based on code by Adam Auton, from Nov 11 2009.
 *
// Class for reading in, checking and storing user parameters
*/


// Class for reading in, checking and storing user parameters
#ifndef PARAMETERS_H_
#define PARAMETERS_H_

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <limits>
#include <string>
#include <vector>
#include <set>

#include "random.h"
#include "read_data.h" // to enable hapmapParams is this file
#include "argumentsOfProgram.h"

//#include "output_log.h"

using namespace std;

class parameters : public argumentsOfProgram
{
public:
  parameters(const int& argc, char* argv[]);
  parameters() :
    argumentsOfProgram()
  {
    cout << "  WARNING!! you've chosen to keep the default for all parameters. Did you mean to?\n";
    cout << "  Press any key to continue:";
    getchar();
    cout << "\n";
  };

  ~parameters(){};

	void read_parameters();
	void print_help(bool quit=false);
	void print_params();

private:
	void check_parameters();
	static void error(string err_msg, int code);

	vector<string> argVector;

	string get_arg(unsigned int i);
};

bool convertStringToBool(const string& inString);

#endif /* PARAMETERS_H_ */
