#include "read_data.h"


//void Read_Data(int& smpl_size, int& all_sites, int& no_segsts,  bool& using_rec_map, bool& print_data, vector<double>& site_posns, const int& which_set, string data_Fname, vector< vector<int> >& data)
void Read_Data(int& smpl_size, int& all_sites, int& no_segsts,  bool& using_rec_map,
    bool& print_data, vector<double>& site_posns, const int& which_set, Con& con, string data_Fname,
    vector< vector<int> >& data, double DEBUG) // , double DEBUG for some reason even thoguh I gave it a default this caused problems
{
	int i,j, check;
	int stop;
	int data_unit;
	ifstream DataF;
	char inchar;
	//double DEBUG = 1;
	DataF.open(data_Fname.c_str(),ios::in);
	if(!DataF.good() || !DataF.is_open()) 
	{
		cout << "Warning, problem opening data file.\n";
		cout << "The data file was " << data_Fname.c_str() << "\n";
	}
	
	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> smpl_size;
			stop = 1;
		}
	}
	con.smpl_size = smpl_size;

	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> all_sites;
			stop = 1;
		}
	}
	con.all_sites = all_sites;

	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> using_rec_map;
			stop = 1;
		}
	}
	con.using_rec_map = using_rec_map;

	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> print_data;
			stop = 1;
		}
	}
	con.print_data = print_data;

	bool ms_style_data;
	int no_datasets;
	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> ms_style_data;
			stop = 1;
		}
	}

	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> no_datasets;
			stop = 1;
		}
	}
	if(which_set > no_datasets)
	{
		cout << "Warning, specified an invalid data_set (" << which_set << " out of " << no_datasets << ") to analyse.\n";
		getchar();
	}

	// Choose which data_set to read in
	// Obtain parameters for data set (No Sites, Site Positions)
	// Read in the data itself.
	for(i=0; i<which_set; i++)
	{
		stop = 0;
		while (DataF.good() && !DataF.eof() && stop == 0)
		{
			inchar = DataF.get();
			if(inchar == '/') 
			{
				inchar = DataF.get();
				if(inchar == '/') 
					stop = 1;
				else
				{
					cout << "Warning, unable to properly read in the data.\n";
					getchar();
				}
				break;
			}
		}
	}
	
	stop = 0;
	while (DataF.good() && !DataF.eof() && stop == 0)
	{
		inchar = DataF.get();
		if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
		{
			DataF >> no_segsts;
			stop = 1;
		}
	}
	site_posns.resize(no_segsts);
	con.no_segsts = no_segsts;


	if(ms_style_data)		
	{
		if(no_segsts > 5000)
		{
			cout << "Producing "<< no_segsts << " equally spaced sites for Genealogy Analysis with lots of sites.\n";
			for(j=0; j<no_segsts; j++)
				site_posns.at(j) = double(j)/(double)no_segsts;
			data.resize(smpl_size);
			for (i=0; i<smpl_size; i++)
				data.at(i).resize(no_segsts,-99);
			for (i=0; i<smpl_size; i++)
				for(j=0; j<no_segsts; j++)
					data.at(i).at(j) = 1;
		}

		else
		{
			stop = 0;
			while (DataF.good() && !DataF.eof() && stop == 0)
			{
				inchar = DataF.get();
				if(inchar == ':') //Note single quotes refer to characters, double quotes refer to char*
				{
					for(j=0; j<no_segsts; j++)
						DataF >> site_posns.at(j);
					//for(j=0; j<no_segsts; j++)
					//	cout << site_posns.at(j) << " ";
					stop = 1;
				}
			}
			for(check=1; check<(int)site_posns.size(); check++)
			{
				if(site_posns.at(check) - site_posns.at(check-1) < 0) 
				{
					cout << "Error! Site positions corrupt. Site " << check << " is too big.\n";
					getchar();
					//exit(1);
				}
			}
			// Construct Matrix to hold the input data.
			data.resize(smpl_size);
			for (i=0; i<smpl_size; i++)
			{
				data.at(i).resize(no_segsts,-99);
			}

			for (j=0; j< smpl_size; j++)
			{
				stop = 0;
				while (DataF.good() && !DataF.eof() && stop == 0)
				{
					inchar = DataF.get();
					if(inchar == '#') 
					{
						cout << "Warning, not as many input sequences as promised\n";
						getchar();
						break;
					}
					if(inchar == '>') //Note single quotes refer to characters, double quotes refer to char*
					{
						stop = 1;
					}
				}
				for (i=0; i< no_segsts; i++)
				{
					if (DataF.good() && !DataF.eof()) 
					{
						inchar = DataF.get();
						if (inchar == '0')
							data.at(j).at(i) = 1;
						else
						{
							if(inchar == '1')
								data.at(j).at(i) = 2;
							else
							{
								cout << "Warning, unexpected data type.\n";
								cout << "The data file was " << data_Fname.c_str() << "\n";
								getchar();
							}
						}          if(data.size()==0) {
	            cout << "  Warning! data is of size 0 (in constructor1). Problem reading in data?\n";
	            getchar();
	          }

					}
					else
					{
						if(!DataF.good())
						{
							cout << "The data being read in is not `good'\n Have probably not got enough segregating sites.\n";
							cout << "The data file was " << data_Fname.c_str() << "\n";
							getchar();
							break;
						}
						if(DataF.eof())
						{
							cout << "Have prematurely reached the end of the data input file\n";
							cout << "The data file was " << data_Fname.c_str() << "\n";
						}
					}
				}
			}
		}
	}	

	else
	{
		// Construct Matrix to hold the input data.
		data.resize(smpl_size);
		for (i=0; i<smpl_size; i++)
		{
			data.at(i).resize(no_segsts,-99);
		}

		for (j=0; j< smpl_size; j++)
		{
			stop = 0;
			while (DataF.good() && !DataF.eof() && stop == 0)
			{
				inchar = DataF.get();
				if(inchar == '#') 
				{
					cout << "Warning, not as many input sequences as promised\n";
					getchar();
					break;
				}
				if(inchar == '>') //Note single quotes refer to characters, double quotes refer to char*
				{
					stop = 1;
				}
			}
			for (i=0; i< no_segsts; i++)
			{
				if (DataF.good() && !DataF.eof()) 
					DataF >> data_unit;							
				else
				{
					if(!DataF.good())
					{
						cout << "The data being read in is not `good'\n Have probably not got enough segregating sites.\n";
						cout << "The data file was " << data_Fname.c_str() << "\n";
						getchar();
						break;
					}
					if(DataF.eof())
					{
						cout << "Have prematurely reached the end of the data input file\n";
					}
				}
				data.at(j).at(i) = data_unit + 1;			// Do this because a '0' allele refers to NON ANCESTRAL material			
			}	
		}
	}

	int max_data_size = 20000;
	map<double, snp> hapmapDat; // Blank map being passed to printData, this will be detected within that function.
  printData(
      no_segsts,
      smpl_size,
      data         , // the data to be printed to screen
      site_posns   , // The (genetic map) locations of the SNPs
      hapmapDat    , // This contains the physical position
      max_data_size, // max data size to print
      which_set    , // which data set
      print_data   ,  // print_data (should it be printed?)
      DEBUG
    );
	DataF.close();
}


// This function uses the data read in from the hapmap files and sets the familiar objects of this prgoram from those
// So this function sets:
//   smpl_size, no_segsts
// And populates: Ancestry::data
void setMyDatFromHapmap(
      const map<double, snp>& hapmapDat   ,
      vector < vector<int> >& myFormatHaps,
      vector<double>&         site_posns  ,
      Con&                    con         ,
      double DEBUG
    )
{
  // Some of these variables aren't used in the program, I set them to default values here:
  con.all_sites = 1e3;
  // End of setting unused variables to default values.

  // As we are using IMPUTE format data we are using a recombination map.
  // However at present this is being handled by the read_genetic_map code, not mine!
  con.using_rec_map = false;

  map<double, snp>::const_iterator tempIter = hapmapDat.begin();
  if(con.debugMaxNumHaps < 0) // This essentially tests for the default value: -1
  {
    con.smpl_size = tempIter->second.haps.size();
  } else {
    cout << "  Warning! (potentially) artificially reducing the number of haplotypes for debugging.\n";
    con.smpl_size = min(con.debugMaxNumHaps, (int)tempIter->second.haps.size());
  }
  //con.smpl_size = hapmapDat.begin().haps.size();
  con.no_segsts = hapmapDat.size();

  // Resizing data containers based on dimensions from above:
  int index;
  site_posns.resize(con.no_segsts);


  myFormatHaps.resize(con.smpl_size);
  for (index=0; index<con.smpl_size; index++)
    myFormatHaps.at(index).resize(con.no_segsts,-99);

  int tempPos, valueUnderMyCoding, valueUnderImputeCoding;
  int jndex;
  snp tempSNP;
  index = 0;
  for(map<double, snp>::const_iterator it = hapmapDat.begin(); it != hapmapDat.end(); ++it)
  {
    tempSNP = it->second;
    tempPos = it->first ;
    bool checkSampSize = (int)tempSNP.haps.size() == con.smpl_size;
    checkSampSize = checkSampSize || (con.debugMaxNumHaps>0 && (con.smpl_size==con.debugMaxNumHaps));
    if(!checkSampSize) {
      cout << "  Warning, expected " << con.smpl_size
           << ", got " << tempSNP.haps.size() << " individuals, \n";
    }

    // Set the GENETIC positions of the sites:
    site_posns.at(index) = tempSNP.gen_pos;

    // Set the haplotype values for each individual at this SNP
    for(jndex=0; jndex< con.smpl_size; jndex++)
    {
      valueUnderImputeCoding = tempSNP.haps.at(jndex)  ;
      valueUnderMyCoding     = valueUnderImputeCoding+1; // I use 1/2 for the two types (0 = non-ancestral)
      myFormatHaps.at(jndex).at(index) = valueUnderMyCoding;
    }
    index++;
  }
  bool checkNumSites = index==con.no_segsts;
  if(!checkNumSites) {
    cout << "  Warning, expected " << con.no_segsts
         << ", got " << index << " SNPs (segSites), \n";
  }
  cout << endl;
  if(DEBUG>=2) {
    cout << "Site positions (on the genetic map scale):\n";
    if(site_posns.size()>4) {
         cout << "1=" << site_posns.at(1) << ", ";
         cout << "2=" << site_posns.at(2) << ", ";
         cout << "(end-1)=" << site_posns.at(site_posns.size()-2) << ", ";
         cout << "(end)=" << site_posns.at(site_posns.size()-1) << ", ";
         cout << "\n";
       }
  }
  printData(
      con.no_segsts,
      con.smpl_size,
      myFormatHaps , // the data to be printed to screen
      site_posns   , // The (genetic map) locations of the SNPs
      hapmapDat    , // This contains the physical position
      20000        , // max data size to print
      1            , // which data set
      true         , // print_data (should it be printed?)
      DEBUG
    );
  //if(data.size()==0) {
  if(myFormatHaps.size()==0) {
    cout << "  Warning! myFormatHaps is of size 0 (in setMyDatFromHapmap). Problem reading in data?\n";
    getchar();
  }
  return;
}


// hapDat is the structure that stores haplotype data and genotype data in a snp by snp way
void read_genetic_map(
    const ChapmapParams params,
    vector<double>&     genmap, // genetic map for region
    vector<double>&    physmap, // physical map for region
    double DEBUG
)
{
  /**
   * read in genetic map
   * map file format
   * position COMBINED_rate(cM/Mb) Genetic_Map(cM)
   * 14431347 8.0969920631262 0
   * 14432618 8.13151978955012 0.0102912769122334
   * 14433624 8.13196693718614 0.0184715858205208
   * 14433659 8.13262480427772 0.0187562046633223
   * 14433758 8.12960594753954 0.0195613345189458
   * 14434713 8.02477179402559 0.0273251081988461
   * 14434960 8.02692050850737 0.0293072268319704
   * 14435070 5.68314838223086 0.0301901880879062
   * 14435171 5.68596505729921 0.0307641860745115
   * 14435207 5.68961975412486 0.0309688808165743
   * The physical position and genetic map are stored in physmap and genmap
  */
  double tmp1;
  int line_count = 0;
  ifstream ifs_rates;
  string line;
  stringstream ss_rates;

  cout << "reading genetic map file ... " << flush;

//  if(params.map_file.c_str()=="testFiles/testMap1.txt")
  if(params.map_file=="testFiles/testMap1.txt")
    cout << "  Warning - using default genetic map filename. Is this just a test? use -genMap at command line.\n";

  ifs_rates.open(params.map_file.c_str());
  if(!ifs_rates.is_open())
    throw badfilename(params.map_file, "can't open file.");

  // ignore header line
  getline(ifs_rates, line);

  // store physical and genetic maps in physmap and genmap
  cout << "Using the scale: " << params.rhoScale << " for the recombination map.\n";
  while(getline(ifs_rates, line)) {
    line_count++;
    ss_rates.clear();
    ss_rates.str(line);

    ss_rates >> tmp1;
    physmap.push_back(tmp1);
    ss_rates >> tmp1;
    ss_rates >> tmp1;
    if(params.rhoScale=="cMperMb")
      genmap.push_back(tmp1);
    else if (params.rhoScale=="coalescentScale")
      genmap.push_back(4 * params.Ne * tmp1 / 100);
    else {
      cout << "  Error, unrecognised recombination rate scale (cMperMb or coalescentScale allowed)\n";
      cout << "  Press Ctrl+C to exit.";
      getchar();
    }

    if(ss_rates.bad()){
      stringstream ss_exception;
      ss_exception << "bad line in rates file on line " << line_count+1;
      throw badfilename(params.map_file, ss_exception.str().c_str());
    }
  }
  cout << "done." << endl;
  ifs_rates.close();
  //cout << std::setw(params.display_width) << std::right << "number of rates read: " << line_count << endl << endl;
  cout << std::setw(10) << std::right << "number of rates read: " << line_count << endl;

  //cout << "  Warning!! Not rescaling map when reading in hapmap genetic map.\n";
  //rescale_map();

  return;
}

void read_haplotype_data(
    const ChapmapParams     params ,
    map<double, snp>&       hapDat ,
    const vector<double>&   genmap , // genetic map for region
    const vector<double>&   physmap, // physical map for region
    int n_gen, int n_hap,
    int DEBUG
    )
{
  /**
   * Read in known haplotypes and legend file
   * haps file format
   * 1 1 1 . .  known hap snp 1
   * 0 0 1 . .  known hap snp 2
   * . .

   * legend file format
   * rs         position 0 1
   * rs11089130 14431347 C G
   * rs738829   14432618 A G
   * rs7510853  14432918 - C
   * rs10154488 14433591 - C
   * rs915674   14433624 A G
   *
   * stores rsid at each SNP as rs, genetic position as gen_pos,
   * haplotypes SNP of panel as haps, frequency of 1 allele as
   * haps_1_freq, allele coded by 0 as haps_0 and 1 as haps1.
   *
   * only SNPs in the specified region + buffer are stored.
  */
  double SNPpos, allele_count;
  ifstream ifs_haps, ifs_legend;
  int line_count = 0, h;
  snp tmpsnp;
  string haps_line, legend_line;
  stringstream ss_haps, ss_legend;
  vector<int> snp_haps;

  cout << "\nReading haplotype and legend files, ";
  cout << "looking for SNPs in [" << (params.lower - (params.buffer * 1000)) << ", "
                                  << (params.upper + (params.buffer * 1000)) << "] ... ";
  cout.flush();
  if(DEBUG>1) {
    cout << "  \n";
    cout << "  params.legend_file     = " << params.legend_file     << "\n";
    cout << "  params.haps_file.fName = " << params.haps_file.fName << "\n";
    cout << "  params.map_file        = " << params.map_file        << "\n";
  }
  if(params.legend_file=="testFiles/testLegend1.txt")
    cout << "  Warning - using default legend filename. Is this just a test? use -legend at command line.\n";
  if(params.haps_file.fName=="testFiles/testHaps1.txt")
    cout << "  Warning - using default haplotypes filename. Is this just a test? use -haplotypes at command line.\n";
  if(params.upper<0 || params.lower<0 || params.buffer<0) {
    cout << "  Warning! None o: upper, lower or buffer should be negative!\n";
    cout << "  have the defaults been changed?\n";
    cout << "  params.upper=" << params.upper << ", params.lower=" << params.lower << " and params.buffer=" << params.buffer << "\n";
    cout << "  Press any key to continue.";
    getchar();
    cout << "\n";
  }
  // reset the number of haplotypes
  n_hap = -1;

  // open files and throw exception if can't open them
  ifs_haps.open(params.haps_file.fName.c_str());
  if(!ifs_haps.is_open())
    throw badfilename(params.haps_file.fName, "can't open haplotype file.");

  ifs_legend.open(params.legend_file.c_str());
  if(!ifs_legend.is_open())
    throw badfilename(params.legend_file, "can't open legend file.");
  getline(ifs_legend, legend_line);

  while(!getline(ifs_haps, haps_line).fail() & !getline(ifs_legend, legend_line).fail()){
    line_count++;
    snp_haps.clear();

    ss_haps.clear();
    ss_legend.clear();
    ss_haps.str(haps_line);
    ss_legend.str(legend_line);

    //read legend file and get rsid , physical position, allele
    //coded by 0, allele coded by 1
    ss_legend >> tmpsnp.rs;
    //cout << tmpsnp.rs << endl;
    ss_legend >> SNPpos;
    //cout << SNPpos << endl;
    tmpsnp.id = "---";
    //cout << tmpsnp.id << endl;
    tmpsnp.gen_pos = phys2gen(SNPpos, genmap, physmap);
    //cout << tmpsnp.gen_pos << endl;
    tmpsnp.gens_0 = "*";
    tmpsnp.gens_1 = "*";
    ss_legend >> tmpsnp.haps_0;
    ss_legend >> tmpsnp.haps_1;
    allele_count = 0;
    // read haplotype file to get the haplotype SNP for all
    // individuals

    if(!ss_haps.good()) {
      cout << "  Warning! haplotypes file ifstream.good() is now false.\n";
      cout << "  No alleles read in at this point.\n";
      cout << "  The haplotypes filename is: " << params.haps_file.fName.c_str() << "\n";
      getchar();
      exit(1);
    }
    for(ss_haps >> h; !ss_haps.eof() ; ss_haps >> h){
      snp_haps.push_back(h);
      allele_count += h;
      if(!ss_haps.good()) {
        cout << "  Warning! haplotypes file ifstream.good() is now false.\n";
        cout << "  " << allele_count << " alleles read in at this point.\n";
        cout << "  The haplotypes filename is: " << params.haps_file.fName.c_str() << "\n";
        cout << "  Is this definitely the right name of the _haplotypes_ file?\n";
        getchar();
        exit(1);
      }
      if(snp_haps.size()>1e8) {
        cout << "\n  Warning, more than 100 million alleles read in. Is something wrong?\n";
        cout <<   "  Press any key to continue.\n";
        getchar();
      }
    }
    if(!ss_haps.fail()){
      snp_haps.push_back(h);
      allele_count += h;
    }

    tmpsnp.haps = snp_haps;
    tmpsnp.haps_1_freq = ((double) allele_count) / ((double)snp_haps.size());
    tmpsnp.gens_strand = "*";
    tmpsnp.type = 1;

    // sanity checks
    if(ss_legend.bad()){
      stringstream exception_ss;
      exception_ss << "bad format detected in legend file on line " << line_count+1 << ".";
      throw badfilename(params.legend_file.c_str(), exception_ss.str().c_str());
    }

    if(ss_haps.bad()){
      stringstream exception_ss;
      exception_ss << "bad format detected in haplotype file on line " << line_count << ".";
      throw badfilename(params.haps_file.fName.c_str(), exception_ss.str().c_str());
    }

    if(n_hap == -1){
      n_hap = snp_haps.size();
    } else{
      if(n_hap != (int)snp_haps.size()){
        stringstream exception_ss;
        exception_ss << "different number of haplotypes found in haplotype file ("
            << n_hap << " and " << snp_haps.size() << " on line " << line_count << ".";
        throw badfilename(params.haps_file.fName, exception_ss.str().c_str());
      }
    }

    // only store if in the right location
    if(SNPpos <= (params.upper + (params.buffer * 1000))) {
      if(SNPpos >= (params.lower - (params.buffer * 1000))) {
        hapDat.insert(make_pair(SNPpos, tmpsnp));
        //cout << SNPpos << " " << tmpsnp.rs << " " << tmpsnp.haps_1_freq << endl;
      }
    } else {
      break;
    }
  }
  cout << "done." << endl;

  cout << std::setw(params.display_width) << std::right << "number of haplotypes: " << n_hap << endl;
  cout << std::setw(params.display_width) << std::right << "number of SNPs in total: " << line_count << endl;
  cout << std::setw(params.display_width) << std::right << "number of SNPs in interval: " << hapDat.size() << endl << endl;

  if(ifs_legend.eof() && !ifs_haps.eof()){
    cout << "Warning: haplotype file contained more lines than legend file, only those SNPs with a line in the legend file were read." << endl;
  }
  if(ifs_haps.eof() && !ifs_legend.eof()){
    cout << "Warning: legend file contained more lines than haplotype file, only those SNPs with a line in the haplotype file were read." << endl;
  }

  ifs_haps.close();
  ifs_legend.close();

  if(hapDat.size() == 0) {
    throw badfilename(params.haps_file.fName, "No SNPs in the interval in haplotype file!");
  }

  return;
}

/**
 * Read sample file for sample exclusions
 *
 */
void read_sample_file(
    const ChapmapParams params,
    int n_gen,
    map<string, int> sample_id_to_index_map)
{
  //read sample file
  ifstream ifs_sample;
  int id_index = 0;
  string line_sample, sample_id1, sample_id2;
  stringstream ss_sample;

  cout << "Reading sample file ... " << flush;
  ifs_sample.open(params.sample_file.fName.c_str());
  if(!ifs_sample.is_open()){
    throw badfilename(params.sample_file.fName, "can't open sample file.");
  }
  getline(ifs_sample, line_sample);
  getline(ifs_sample, line_sample);

  sample_id_to_index_map.clear();
  while(getline(ifs_sample, line_sample)){
    ss_sample.clear();
    ss_sample.str(line_sample);
    ss_sample >> sample_id1;
    ss_sample >> sample_id2;
    sample_id_to_index_map.insert(make_pair(sample_id1, id_index));
    sample_id_to_index_map.insert(make_pair(sample_id2, id_index));

    id_index++;
  }
  if(id_index != n_gen){
    throw badfilename(params.sample_file.fName, "sample file contains wrong number of individuals.");
  }
  ifs_sample.close();

  cout << "done" << endl << endl;
}

/**
 * Reads the file with the sample ids of individuals to be excluded
 */
void read_sample_exclusion_file(
    const ChapmapParams params,
    vector<string> exclusion_list_samples){

  cout << "Reading sample exclusion file ... " << flush;

  // read exclusion
  ifstream ifs_exclusion;
  string sample_id1;
  ifs_exclusion.open(params.exclude_samples.fName.c_str());
  if(!ifs_exclusion.is_open()){
    throw badfilename(params.exclude_samples.fName, "can't open sample file.");
  }
  exclusion_list_samples.clear();
  for(ifs_exclusion >> sample_id1; !ifs_exclusion.fail(); ifs_exclusion >> sample_id1){
    exclusion_list_samples.push_back(sample_id1);
  }
  ifs_exclusion.close();
  cout << "done" << endl;
  cout << std::setw(params.display_width) << std::right << "number of ids in sample exclusion list: " << exclusion_list_samples.size() << endl << endl;
}

/**
 * Convert a physical map position to a genetic map position
 *
 * @params physical position
 */
double phys2gen(
    const double physpos,
    const vector<double> genmap, // genetic map for region
    const vector<double> physmap // physical map for region
)
{
  int k;
  double genpos;
  k = 0;
  while(physpos >= physmap[k] && k < (int)physmap.size()) {
    k++;
  }

  if(k==0){
    genpos = genmap[0];
  } else{
    k--;
    if(k == (int)physmap.size() - 1){
      genpos = genmap[k];
    } else{
      genpos = genmap[k] + ((physpos - physmap[k]) / (physmap[k+1] - physmap[k])) * (genmap[k+1] - genmap[k]);
    }
  }

  return genpos;
}
void print_files(const ChapmapParams params) {

  cout << "haplotypes file : " << params.haps_file.fName.c_str() << endl;
  cout << "    legend file : " << params.legend_file << endl;
  cout << " genotypes file : " << params.gens_file.fName.c_str() << endl;
  cout << "       map file : " << params.map_file << endl;
  cout << "    strand file : " << params.strand_file.fName.c_str() << endl;

}

void print_params(
    const ChapmapParams params,
    const double theta,
    const int n_hap, // # haplotypes
    const int n_gen // # genotypes
    )
{

  cout << endl;
  cout.flags();
  cout << "      n_hap : " << n_hap << endl;
  cout << "      n_gen : " << n_gen << endl;
  cout << "       nind : " << params.nind << endl;
  cout << "   interval : [" << fixed << setprecision(0) << params.lower << ", " << fixed << setprecision(0) << params.upper << "]" << endl;

  cout << "     buffer : " << params.buffer << endl;
  cout << "         Ne : " << params.Ne << endl;
//cout << "call_thresh : " << setprecision(3) << params.call_thresh << endl;
  cout << "      theta : " << setprecision(5) << theta << endl << endl;
}

/*int countLines (string fl) {

  int ct;
  ifstream in;
  in.open(fl.c_str());
  ct = count(istreambuf_iterator<char>(in), istreambuf_iterator<char>(), '\n');
  in.close();
  return ct;

}*/

void printData(
    const int& no_segsts,
    const int& smpl_size,
    const vector< vector<int> >& data,
    const vector<double       >& site_posns,
    const map<double, snp     >& hapmapDat,
    int        max_data_size,
    int        which_set    ,
    bool       print_data   ,
    double     DEBUG
  )
{
  int numIndsPrint, numSNPsPrint;
  int dataSize  = (no_segsts*smpl_size);
  bool printAll = dataSize < max_data_size;
  if(DEBUG>1.5)
    cout << "There are " << smpl_size << " sequences and " << no_segsts << " sites.\n";
  if(printAll) {
    cout << "The Data Read in this time is (Data set " << which_set << "):" << endl << endl;
    cout << "genPos" << "\t" << "snpID" << "alleles" << endl;
    numIndsPrint = smpl_size;
    numSNPsPrint = no_segsts;
  } else {
    cout << "The full data are too big to print to screen comfortably - printing top left corner\n";
    numIndsPrint = min(40, smpl_size);
    numSNPsPrint = min(20, no_segsts);
  }

  if(print_data)
  {
    bool printPhysPos = hapmapDat.size()>0;
    map<double, snp>::const_iterator tempIter;
    if(printPhysPos)
      tempIter = hapmapDat.begin();
    for (int index=0; index< numSNPsPrint; index++)
    {
      cout << setw(9) << site_posns.at(index);
      if(printPhysPos) {
        cout << " (" << setw(10) << tempIter->second.rs << ")";
        ++tempIter;
      }
      cout << ": ";
      for (int jndex=0; jndex< numIndsPrint; jndex++)
        cout << (data.at(jndex).at(index))-1 << "";
      cout << endl;
    }
    cout << endl << endl;
  }
  return;
}
