#ifndef WRITE_TREES_H
#define WRITE_TREES_H

//Memory leak detection:
//#define CRTDBG_MAP_ALLOC
#include <stdlib.h>
//#include <crtdbg.h>

#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <string>
#include <sstream>
#include <fstream>
#include <vector>
#include <map>
#include <sys/types.h>  // For stat().
#include <sys/stat.h>   // For stat().

#include "node.h"
#include "recomb_event.h"
#include "control.h"
#include "event.h"
#include "snp.h"


using namespace std;

void Write_Tree(
    const vector< vector<node> >& marg_gens,
    const map<double, snp>&  hapmapDat,
    const vector<recomb_event>&   rec_records,
    const vector<CEvent>&  event_vector,
    const vector<double>&  choice_quotients,
    const int& rec_sites,
    const double& rho,
    const int& smpl_size,
    const bool& SMC,
    const bool& all_nodes,
    const vector<double>& positions,
    const Con&    con,
    const string& outputDir,
    // The following arguments must all have defaults
    //const string& outputDir    ="."
    const string& writeType    = "oldStyle", // "allEvents", "ZhanMark1" also possible. Want to produce: GENECLUSTERstyle, and (similar) treePerLine
    int           writeVerbose = 2
);

void writeGeneclusterTree(
    const map<double, snp>& hapmapDat       , const int&                    smpl_size   ,
    ofstream &              treeFile        , const vector< vector<node> >& marg_gens   ,
    const vector<double>&   choice_quotients, const vector<CEvent>&         event_vector,
    int gcVerbose=1);
void generateOrderedCoalescences(
    vector< vector<int> >& coalescences,
    const vector< vector<node> >& marg_gens,
    const int& smpl_size,
    const int& site,
    int& verbose
  );
void writeOutputUnit(int& verbose, stringstream& outputUnit, ofstream& fileStream);

void checkDirectory(const string& strPath, int verbose, string& dirStatus, bool stopOnProblem=true);

void writeTreePreamble(ofstream& tree_file, string& tree_fileN, const int& rec_sites, const double& rho, const int& smpl_size, const int& SMC);
void oldWriteMainTree(const int& rec_sites, const int& start_node, const int& smpl_size, ofstream & tree_file, const vector<vector<node> >& marg_gens);
void snpNamesFileError(ifstream& snp_namesF, const Con& con);
void automaticallyNameFilesWhenSNPsFileNotGiven(vector<string>& file_suffices, const Con & con);
void makeSingleTreesFname(const Con& con, string& tree_fileN, const string& outputDir, const string& writeType);
void oneTreePerFileWriteMainTree(
    const int& rec_sites, const      Con& con  , const string& outputDir,
    const vector<string>& file_suffices,
    const int& smpl_size, const int& start_node,
    const vector<vector<node> >& marg_gens, const int& j);
void makeSNPnamedTreeFilenames(const Con& con, vector<string>& file_suffices, const int& rec_sites, string& suffix);
void makeTreeFileName(
    const Con& con,
    const string& outputDir,
    const vector<string>& file_suffices,
    const int& j,
    const int& smpl_size,
    string& treeFilename);
void writeAllEventsData(
    ofstream&               tree_file       ,
    const vector<double>&   choice_quotients,
    const vector<CEvent>&   event_vector    ,
    const vector<vector<node> >& marg_gens
  );
#endif
