/*
 * snp.h
 *
 *  Created on: Jun 8, 2010
 *      Author: niall - based on code by Jonathan Marchini
 */

#ifndef SNP_H_
#define SNP_H_

struct snp { // structure for containing all the info at a given SNP
  string rs; // rs id of SNP
  string id; // spare id for SNP i.e. Affy ID
  double gen_pos; // genetic map position of SNP

  vector<int> haps; // haplotype data at SNP
  string haps_0; // allele coded 0
  string haps_1; // allele coded 1
  double haps_1_freq; // frequency of 1 alleles in haplotypes
  string haps_strand; // strand of coding for haplotype data

  vector<int> genotypes; // genotype data at SNP
  vector<vector<double> > genotype_probs; // genotype probabilities at SNP
  string gens_0; // allele coded 0
  string gens_1; // allele coded 1
  double gens_1_freq;
  string gens_strand; // strand of coding for genotype data

  int type; // 1 = haplotypes only, 2 = haplotypes and genotypes

  double rate; // recombination rate to left of site
  vector<double> switchmap; // vector of switch rates from previous SNP in multimap to this SNP

  vector<vector<double> > predictions; // genotype predictions
  double certainty; // average prediction
  double brier; // average brier score of called genotypes at snps of type = 2

  vector<vector<double> > backward_path;
  vector<vector<double> > forward_path;
};

#endif /* SNP_H_ */
